(function($) {
  'use strict';

  if (wpsObject === undefined) {
    return;
  }

  $(document).on('click', '.tabs-nav > li a', function(e) {
    var showTab = $(this).attr('data-active');
    var showTabGroup = $(this).attr('data-tabgroup');
    $('.tabs-nav' + showTabGroup + ' > li').removeClass('active');
    $(this).parent().addClass('active');
    $('.tabs-box' + showTabGroup).hide();
    if (showTabGroup == '.parent-tabs') {
      $('.tabs-nav.child-tabs > li').removeClass('active');
      $('.tabs-nav.child-tabs > li:nth-child(1)').addClass('active');
      $('.child-tabs').hide();
      $('.child-tabs:nth-child(1)').show();
    }
    $(showTab).show();
    e.preventDefault();
  });

  $(document).ready(function() {
    $('.select2_field_product').select2({
      placeholder: wpsObject.placeholderSearchProduct,
    });
    $('.select2_field_category').select2({
      placeholder: wpsObject.placeholderSearchCategory,
    });
    $('.select2_field_custom_fields').select2({
      placeholder: wpsObject.placeholderSearchCustomFields,
    });
    $('.select2_field_attribute').select2({
      placeholder: wpsObject.placeholderSearchAttribute,
    });

    // Trigger product indexing
    $('.psf-cache-generate-button, .psf-build-cache-button').click(function() {
      $('.psf-progress').width('1%');
      psfStartIndexingCache();
    });

    function psfStartIndexingCache() {
      // Show/hide relevant messages/buttons
      $('.psf-welcome-h2, .psf-lets-get-setup, .psf-needs-generate-para, .psf-cache-generate-button, .psf-cache-build-success-notice, .psf-cache-build-notice').
          hide(0);
      $('.psf-progress-bar, .psf-wait-h2, .psf-keep-open-para, .psf-progress-bar-wrapper').show(0);

      $.ajax({
        type: 'post',
        dataType: 'json',
        url: wpsObject.ajaxUrl,
        data: {action: 'psf_cache_rebuild'},
        success: function(response) {

          if (response.status == 1) {
            $('.psf-all-good-para, .psf-goto-settings-button, .psf-cache-build-success-notice').show();
            $('.psf-wait-h2, .psf-keep-open-para, .psf-cache-build-notice, .psf-progress-bar-wrapper').hide(0);
          }
          else {
            $('.psf-progress').width(response.percentage + '%');
            psfStartIndexingCache();
          }
        },
      });
    }

  });

  $(document).on('click', '#rebuild_cache', function(e) {
    $('#cache_success_message').hide();
    $.ajax({
      type: 'post',
      dataType: 'json',
      url: wpsObject.ajaxUrl,
      data: {action: 'cache_rebuild'},
      success: function(response) {
        $('#cache_success_message').show();
      },
    });
  });

})(jQuery);
