<?php

/**
 * Admin area settings template for cache wizard file
 *
 * @link       https://kankode.com/
 * @since      1.0.0
 *
 * @package    Product_Search_Filters
 * @subpackage Psf_Product_Search_Filters/admin/partials
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
?>
<div class="psf-cache-wizard-wrapper">
    <div class="psf-cache-wizard-container">
        <div class="psf-cache-wizard-header">
            <img class="psf-cache-wizard-logo"
                 src="<?php echo plugin_dir_url( __DIR__ ) . '/img/psf-logo.svg' ?>"
                 alt="KanKode Logo"/>
        </div>
        <div class="psf-cache-wizard-content">
            <div class="psf-cache-wizard-body">
                <div class="psf-progress-bar" style="display: none;">
                    <div class="psf-progress" style="width:0%"></div>
                </div>

                <h2 class="psf-welcome-h2"><?php esc_html_e( 'Welcome to WooSearch!', 'product-search-and-filters' ); ?></h2>
                <h2 class="psf-wait-h2" style="display: none;"><?php esc_html_e( 'Please wait..', 'product-search-and-filters' ); ?></h2>
                <p class="psf-keep-open-para" style="display: none;"><?php esc_html_e( 'Please keep this browser window open until the cache build is completed.', 'product-search-and-filters' ); ?></p>
                <p class="psf-lets-get-setup"><?php esc_html_e( 'Let’s get you set up.', 'product-search-and-filters' ); ?></p>
                <p class="psf-needs-generate-para"><?php esc_html_e( 'We need to generate an index of your products. This is a one-time process. Please click below once ready. Do not navigate away or close the page whilst the index is building. This can take a minute or two depending on the number of products your store contains.', 'product-search-and-filters' ); ?></p>
                <p class="psf-all-good-para"
                   style="display: none;"><?php esc_html_e( 'That’s all done. You’re good to go.', 'product-search-and-filters' ); ?></p>
            </div>
            <div class="psf-cache-wizard-footer">
                <button type="button"
                        class="psf-button psf-cache-generate-button"><?php esc_html_e( 'Start Indexing', 'product-search-and-filters' ); ?>
                </button>
                <a href="admin.php?page=product-search-and-filters-settings"
                        class="psf-button psf-goto-settings-button"
                        style="display: none;"><?php esc_html_e( 'Go to WooSearch Settings', 'product-search-and-filters' ); ?>
                </a>
            </div>
        </div>
    </div>
</div>

