'use strict';
//XSS validation
function ValueValidations(val_string) {
    const regex = /^[a-z0-9 ]+$/i;
    if ( !regex.test( val_string ) ) {
        val_string = '';
    }
    return val_string;
}

jQuery( document ).ready( function () {
    let searchField;
    const $ = jQuery;
    let dexter;
    const settings_css = '.ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_bottom_text { background: ' +
        psfSearchConfigs.settings.primary_color +
        '} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_price font.now { background: ' +
        psfSearchConfigs.settings.primary_color +
        '} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_price, .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_price font.symbol, .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_price font.save_price { color: ' +
        psfSearchConfigs.settings.primary_color +
        '}  .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text .free_delivery { border-color: ' +
        psfSearchConfigs.settings.secondary_color +
        '} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text { color: ' +
        psfSearchConfigs.settings.secondary_color +
        '} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .product_price font.tax_text, .ss_modal { color: ' +
        psfSearchConfigs.settings.text_color +
        '} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text svg, .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text .instock svg g, .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text .onbackorder svg g, .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li > .product_box .brand_row > div.brand_text .outofstock svg path { fill: ' +
        psfSearchConfigs.settings.secondary_color + '; } .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li button.psf-cart-btn { color: ' +
        psfSearchConfigs.settings.add_to_cart_text_color +'; background-color: '+ psfSearchConfigs.settings.add_to_cart_bg_color +'} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li button.psf-cart-btn:hover { color: ' +
        psfSearchConfigs.settings.add_to_cart_text_hover_color +'; background-color: '+ psfSearchConfigs.settings.add_to_cart_bg_color +'} .ss_modal .ss_modal_content .ss_modal_results .ss_modal_results_item > ul > li button.psf-cart-btn:before { color: ' +
        psfSearchConfigs.settings.add_to_cart_text_hover_color +'; background-color: '+ psfSearchConfigs.settings.add_to_cart_bg_hover_color +'}';

    const custom_css = psfSearchConfigs.settings.custom_css + settings_css;

    $( '.ss_modal' ).append( '<style>' + custom_css + '</style>' );

    if ( psfSearchConfigs.settings.show_sidebar == 'no' ) {
        $( '.ss_modal_sidebar, .ss_modal_clear' ).remove();
        $( '.ss_modal_results, .ss_modal_search' ).css( 'width', '100%' );
    }

    if ( psfSearchConfigs.settings.dp_stock_status == 'no' ) {
        $( '.brand_text .stock_status' ).remove();
    }

    if ( psfSearchConfigs.settings.display_sale_banner == 'no' ) {
        $( '.product_bottom_text' ).remove();
    }

    if ( psfSearchConfigs.settings.delivery_promotion_text == 'no' ) {
        $( '.brand_text .free_delivery' ).remove();
    }

    if ( psfSearchConfigs.settings.display_product_brand_logo == 'no' ) {
        $( '.brand_image img' ).remove();
    }

    const searchPopup = $('#searchPopup');
    if ( psfSearchConfigs.settings.override_woocommerce_search == 'yes' ) {
        searchField = $('#smart_search, input[name="s"]');
        $( 'input[name="s"]' ).attr( 'placeholder', psfSearchConfigs.settings.search_placeholder );
    } else {
        searchField = $( '#smart_search' );
    }

    $( '#smart_search' ).attr( 'placeholder', psfSearchConfigs.settings.search_placeholder );
    $( '#searching' ).attr( 'placeholder', psfSearchConfigs.settings.search_placeholder );
    const dlgSearchField = $('#searching');
    const dlgCloseHandle = $('#popup_close_button');
    const btnToggleSidebar = $('#toggle');
    const btnCancel = $('#cancel');
    let productsData = [], categoryProducts = [], defaultCategories = [],
        defaultAttributes = {};
    let catSelected, attribSelected, attribSelectedValue;
    let selectedParams = [], total_pages = 0;
    let groupedCategories = [];

    fetch( psfSearchConfigs.url ).then( res => res.json() ).then( data => {
        productsData = data.products;
        defaultCategories = data.categories;
        defaultAttributes = data.attributes;
        _.forEach( defaultCategories, c1 => {
            let g = [];
            g.push( c1.id );
            if ( Array.isArray( c1.childs ) && c1.childs.length ) {
                _.forEach( c1.childs, c2 => {
                    g.push( c2.id );
                    if ( Array.isArray( c2.childs ) && c2.childs.length ) {
                        _.forEach( c2.childs, c3 => {
                            g.push( c3.id );
                        } );
                    }
                } );
            }
            groupedCategories.push( g );
        } );
    } );

    $(document).on('click', '.psf-add-to-cart-btn', function(e) {
        const thisElement = $(this);
        const productId = thisElement.data('product-id');

        $.ajax({
            type: 'post',
            dataType: 'json',
            url: psfSearchConfigs.ajaxUrl,
            data: {action: 'psf_add_to_cart', product_id: productId},
            success: function(response) {
                if (response.status == 1) {
                    thisElement.hide(0);
                    thisElement.next('.psf-view-cart-btn').show();
                }
            },
        });
    });

        $( document ).on( 'click', '.ss_modal_sidebar > ul li[data-type]', function (e) {
        let $me = $( this ), type = $me.data( 'type' ), value = $me.data( 'value' ).toString();
        if ( type == 'cat' ) {
            e.stopPropagation();
            catSelected = value;
            selectedParams.push( { [type]: value } );
        } else {
            attribSelected = type;
            attribSelectedValue = value;
            let pushSelection = true;
            _.forEach( selectedParams, (selection, nSelection) => {
                _.forEach( selection, (selectedValue, selectedType) => {
                    if ( value == selectedValue && type == selectedType ) {
                        pushSelection = false;
                    }
                } );
            } );

            if ( pushSelection ) {
                selectedParams.push( { [type]: value } );
            } else {
                let prevSelectedParams = selectedParams;
                selectedParams = [];
                _.forEach( prevSelectedParams, (selection, nSelection) => {
                    _.forEach( selection, (selectedValue, selectedType) => {
                        if ( value != selectedValue || type != selectedType ) {
                            selectedParams.push( { [selectedType]: selectedValue } );
                        }
                    } );
                } );
            }
        }

        applySearch( '', type, value );
    } );

    function applySearch(searchTerm, searchKey, searchKeyValue) {
        let products = productsData, categories = [], attributes = {};
        let categorySelected = getSelectedCategory() !== null;
        let attributesSelected = getSelectedAttributes().length > 0;
        let searchTermEntered = dlgSearchField.val() !== '';
        if ( categorySelected ) {
            products = filterByCategory( products );
            if ( attributesSelected ) {
                products = filterByAttributes( products );
                if ( searchTermEntered ) {
                    products = filterBySearchTerm( products );
                }
            } else if ( searchTermEntered ) {
                products = filterBySearchTerm( products );
            }
        } else if ( attributesSelected ) {
            products = filterByAttributes( products );
            if ( searchTermEntered ) {
                products = filterBySearchTerm( products );
            }
        } else {
            products = filterBySearchTerm( products );
        }

        renderSidebar( searchTerm, categories, attributes, products );
        renderProducts( searchTerm, products, 1 );
    }

    function filterBySearchTerm(products) {
        let searchTerm = dlgSearchField.val(), filtered = [];
        _.filter( products, product => {
            try {
                let matched;
                if ( psfSearchConfigs.settings.search_params.length ) {
                    for ( let i in psfSearchConfigs.settings.search_params ) {
                        let param = psfSearchConfigs.settings.search_params[i];
                        if ( param === 'description' ) {
                                matched = product.short_description.toLowerCase().indexOf( searchTerm.toLowerCase() ) !== -1;
                            if ( !matched ) {
                                matched = product.long_description.toLowerCase().indexOf( searchTerm.toLowerCase() ) !== -1;
                            }
                        } else if ( param === 'custom_fields' ) {
                            matched = product.search_parameter_fields.toLowerCase().indexOf( searchTerm.toLowerCase() ) !== -1;
                        } else {
                            matched = product[param].toLowerCase().indexOf( searchTerm.toLowerCase() ) !== -1;
                        }
                        if ( matched ) break;
                    }
                } else {
                    matched = product.name.toLowerCase().indexOf( searchTerm.toLowerCase() ) !== -1;
                }

                // Handle further for search term string in multiple ways
                if (!matched) {
                    const searchTermArray = searchTerm.toLowerCase().split(' ');
                    const productTitleArray = product.name.toLowerCase().split(' ');

                    for (let i = 0; i < searchTermArray.length; i++) {

                        // Check if whole word matches
                        let iMatched = productTitleArray.find((item) => {
                            return item.toLowerCase().startsWith(searchTermArray[i].toLowerCase(), 0);
                        });

                        iMatched = iMatched !== undefined;

                        if (!iMatched) {
                            break;
                        }

                        // If this is last result and still matched then its is matched
                        if (i === searchTermArray.length - 1 && iMatched) {
                            matched = true;
                        }
                    }
                }

                if ( matched ) {
                    filtered.push( product );
                }
            } catch ( e ) {
            }
        } );

        categoryProducts = filtered;
        return filtered;
    }

    function filterByCategory(products) {
        let category = getSelectedCategory();
        let relatedCats = [category];
        defaultCategories.forEach( c1 => {
            if ( c1.id == category ) {
                if ( Array.isArray( c1.childs ) ) {
                    c1.childs.forEach( c2 => {
                        relatedCats.push( c2.id );
                        if ( Array.isArray( c2.childs ) ) {
                            c2.childs.forEach( c3 => {
                                relatedCats.push( c2.id );
                            } );
                        }
                    } );
                }
            }
        } );

        products = _.filter( products, product => {
            let matched = false;
            product.cat.forEach( ci => {
                relatedCats.forEach( c => {
                    if ( c == ci.id ) {
                        matched = true;
                    }
                } );
            } );
            return matched;
        } );
        categoryProducts = products;
        return products;
    }

    function filterByAttributes(products) {
        let attributes = getSelectedAttributes();

        products = _.filter( products, product => {
            let matched = false;
            for ( let i in attributes ) {
               let val = attributes[i];
                let key = Object.keys( val )[0];

                if(product.attributes[key] !== undefined) {
                    matched = product.attributes[key].map(
                        a => a.replace("\"", "")).
                        includes(val[key].replace("\"", "").toString());
                    if (matched) break;
                }
            }

            return matched;
        } );
        return products;
    }

    function getSelectedCategory() {
        let c = null;
        _.forEach( selectedParams, p => {
            if ( p.hasOwnProperty( 'cat' ) ) {
                c = p.cat;
            }
        } );
        return c;
    }

    function getSelectedAttributes() {
        let c = [];
        _.forEach( selectedParams, p => {
            if ( !p.hasOwnProperty( 'cat' ) ) {
                c.push( p );
            }
        } );
        return c;
    }

    let paginationSearchTerm, paginationProducts, paginationCurrentPage;

    function renderProducts(search, products, current_page) {

        paginationSearchTerm = search;
        paginationProducts = products;
        paginationCurrentPage = current_page;

        const brand = (psfSearchConfigs.settings.display_product_brand_logo ==
            'no') ? '' : '{% PRODUCT BRAND %}';
        const stock = (psfSearchConfigs.settings.dp_stock_status == 'no')
            ? ''
            : '{% PRODUCT STOCK %}';
        const free_delivery = (psfSearchConfigs.settings.dd_promotion == 'no')
            ? ''
            : '{% PRODUCT DELIVERY %}';
        const sale_banner_text = (psfSearchConfigs.settings.display_sale_banner ==
            'no') ? '' : '{% PRODUCT SALE BANNER %}';

        // Pagination
        current_page = current_page - 1;
        const items_found = products.length;
        const items_per_page = psfSearchConfigs.settings.suggestion_amount
            ? psfSearchConfigs.settings.suggestion_amount
            : 20;
        let startPos = items_per_page * current_page;
        let endPos = parseInt( items_per_page * current_page ) + parseInt( items_per_page );
        total_pages = Math.ceil( items_found / items_per_page );

        // Pagination Rendering
        let $pgContainer = $( '.ss_modal_results_pagination ul' );
        $pgContainer.html( '' );
        if ( items_found > items_per_page ) {
            $pgContainer.append( '<li><a class="goto-first-page" href="javascript:;"> &lt;&lt; </a></li>' );
            if ( current_page > 0 ) {
                $pgContainer.append( '<li><a class="goto-prev-page" href="javascript:;"> &lt; </a></li>' );
            }
            let numarr = [];
            const one = current_page - 1;
            const two = current_page - 2;
            const three = current_page - 3;
            const four = current_page;
            const five = current_page + 1;
            const six = current_page + 2;
            const seven = current_page + 3;
            numarr.push( one, two, three, four, five, six, seven );
            if ( current_page < 4 ) {
                numarr = [0, 1, 2, 3, 4, 5, 6];
            }
            const numarr2 = items_found - 4;
            if ( current_page > numarr2 ) {
                numarr = [];
                for ( let a = 1; a < 8; ++a ) {
                    numarr.push( items_found - a );
                }
            }

            for ( let i = 0; i < total_pages; ++i ) {
                if ( $.inArray( i, numarr ) > -1 ) {
                    let active_page = current_page == i ? 'class="active"' : '';
                    $pgContainer.append( '<li><a ' + active_page + ' href="javascript:;">' + (i + 1) + '</a></li>' );
                }
            }
            if ( current_page < total_pages - 1 ) {
                $pgContainer.append( '<li><a class="goto-next-page" href="javascript:;"> &gt; </a></li>' );
            }
            $pgContainer.append( '<li><a class="goto-last-page" href="javascript:;"> &gt;&gt; </a></li>' );
        }

        let templateCartOptionsBtn = `<button type="button" onClick="window.location.href = '{% PRODUCT LINK %}';" class="psf-cart-btn psf-select-options-btn" id="psf-select-options-btn-{% PRODUCT ID %}">${psfSearchConfigs.selectOptionsTxt}</button>`;
        let templateAddToCartBtn = `<button type="button" class="psf-cart-btn psf-add-to-cart-btn" data-product-id="{% PRODUCT ID %}" id="psf-add-cart-btn-{% PRODUCT ID %}">${psfSearchConfigs.addToCartTxt}</button>`;

        let template = `<li>`;

        // Show add to cart button only if enabled in settings
        if (psfSearchConfigs.settings.dp_add_to_cart == 'yes') {
            template += `<div class="psf-add-to-cart-wrapper">
        {% CART BTN %}
        <button type="button" class="psf-cart-btn psf-view-cart-btn" id="psf-view-cart-btn-{% PRODUCT ID %}" 
        onclick="window.location.href = '${psfSearchConfigs.cartLink}';">${psfSearchConfigs.viewCartTxt}</button>
        <button type="button" onClick="window.location.href = '{% PRODUCT LINK %}';" class="psf-cart-btn psf-view-product-btn" id="psf-view-product-btn-{% PRODUCT ID %}">${psfSearchConfigs.viewProductTxt}</button>
        </div>
        <div class="product_box">`;
        } else {
            template += `<div class="product_box" onClick="window.location.href = '{% PRODUCT LINK %}';">`;
        }

        template += `
		<div class="brand_row clearfix">
		<div class="brand_image">
		${brand}
		</div>
		<div class="brand_text">
		${free_delivery}
		${stock}
		</div>
		</div>
		<div class="product_image">
		<a href="javascript:void(0);"><img src="{% PRODUCT IMAGE %}"></a>
		</div>
		<div class="product_information">
		<div class="product_title">
		{% PRODUCT TITLE %}
		</div>
		<div class="product_price">
		{% PRODUCT PRICE %}
		</div>
		</div>
		${sale_banner_text}
		</div>
		</li>
		`;
        let output = '';
        if ( products.length === 0 ) {
            let searchTerm = ValueValidations( dlgSearchField.val() );
            output = `
			<div class="text-muted">
			<em>${psfSearchConfigs.noResultFoundTxt} <strong>${searchTerm}</strong></em>
			</div>
			`;
        } else {

            products.forEach( function (product, nCount) {
                if ( nCount >= startPos && nCount < endPos ) {
                    const sale_price = (product.sale_price)
                        ? product.sale_price + '<font class="tax_text">' +
                        psfSearchConfigs.settings.tax_text + '</font>'
                        : product.price;
                    const save_price = (product.sale_price) ? 'save ' +
                        product.price_symbol + '' +
                        (parseFloat(product.regular_price) -
                            parseFloat(product.sale_price)).toFixed(2) : '';
                    const regular_price = (product.regular_price)
                        ? '<br><font class="product_original_price">' +
                        product.price_symbol + '' + product.regular_price +
                        '</font>'
                        : '';
                    const price = (product.on_sale)
                        ? '<font class="now">now</font><font class="symbol">' +
                        product.price_symbol + '</font>' + sale_price +
                        regular_price + '<font class="save_price">' +
                        save_price + '</font>'
                        : '<font class="symbol">' + product.price_symbol +
                        '</font>' + product.price + '<font class="tax_text">' +
                        psfSearchConfigs.settings.tax_text + '</font>';

                    const sale_banner = (product.on_sale)
                        ? '<div class="product_bottom_text">' +
                        psfSearchConfigs.settings.sale_banner_text + '</div>'
                        : '<div class="product_bottom_text" style="background: #fff;"></div>';
                    const product_delivery = (product.price >
                        psfSearchConfigs.settings.delivery_details)
                        ? '<span class="free_delivery">' +
                        psfSearchConfigs.settings.delivery_promotion_text +
                        '</span><br>'
                        : '';
                    const stock_status = product.stock_status;
                    const brand = (product.brand_image)
                        ? '<img src="' + product.brand_image + '" alt="' +
                        product.brand + '">'
                        : '';

                    let item = template.replace( new RegExp( '{% PRODUCT TITLE %}' ), product.name )
                        .replace( new RegExp( '{% PRODUCT LINK %}' ), product.permalink )
                        .replace( new RegExp( '{% PRODUCT LINK %}' ), product.permalink )
                        .replace( new RegExp( '{% PRODUCT PRICE %}' ), price )
                        .replace( new RegExp( '{% PRODUCT SALE BANNER %}' ), sale_banner )
                        .replace( new RegExp( '{% PRODUCT STOCK %}' ), stock_status )
                        .replace( new RegExp( '{% PRODUCT DELIVERY %}' ), product_delivery )
                        .replace( new RegExp( '{% PRODUCT BRAND %}' ), brand )
                        .replace( new RegExp( '{% PRODUCT IMAGE %}' ), product.image )
                        .replace( new RegExp( '{% PRODUCT ID %}' ), product.id )
                        .replace( new RegExp( '{% PRODUCT ID %}' ), product.id )

                    let cartBtn = '';

                    if (product.type == 'simple') {
                        cartBtn = templateAddToCartBtn.replace( new RegExp('{% PRODUCT ID %}' ), product.id).
                            replace( new RegExp('{% PRODUCT ID %}' ), product.id);
                    } else {
                        cartBtn = templateCartOptionsBtn.replace( new RegExp('{% PRODUCT LINK %}' ), product.permalink).
                            replace( new RegExp('{% PRODUCT ID %}' ), product.id);
                    }

                    output += item.replace( new RegExp( '{% CART BTN %}' ), cartBtn );
                }
            } );
        }
        $( '.ss_modal_results_item > ul' ).html( output );
    }

    function renderSidebar(search, categories, attributes, products) {
        categories = defaultCategories;
        attributes = defaultAttributes;

        // Prevent categories to remove when click on them
        if ( catSelected && !attribSelected ) {
            categories = defaultCategories;
        }

        let output = '', itemsHTML = '';
        let template = `
		<li>
		<a href="javascript:void(0);">{% HEADING %}</a>
		<ul class="{% FILTER CLASS %}">
		{% LIST %}
		</ul>
		</li>
		`;

        // Categories
        categories.forEach( cat => {
            itemsHTML += '<li data-type="cat" data-value="' + cat.id + '" data-depth="0"><a href="javascript:void(0);">' + cat.name + ' <span class="ss_count">(0)</span>' + '</a>';
            let iChildren = cat.childs.length;
            if ( iChildren == 0 ) {
                itemsHTML += '</li>';
            } else {
                itemsHTML += '<ul>';
                cat.childs.forEach( (child, i) => {
                    itemsHTML += '<li data-type="cat" data-value="' + child.id + '" data-depth="1"><a href="javascript:void(0);">' + child.name + ' <span class="ss_count">(0)</span></a>';
                    itemsHTML += i >= iChildren - 1 ? '</ul></li>' : '</li>';
                } );
            }

        } );
        output += template.replace( new RegExp( '{% HEADING %}' ), 'Categories' ).replace( new RegExp( '{% FILTER CLASS %}' ), 'filter_categories' ).replace( new RegExp( '{% LIST %}' ), itemsHTML );

        // Others
        _.forEach( attributes, (items, attribute) => {
            itemsHTML = '';
            items.forEach( singleItem => {
                itemsHTML += '<li data-type="' + attribute + '" data-value="' + singleItem.name.replace( "\"", "" ) + '"><a href="javascript:void(0);">' + singleItem.name
                    + ' <span class="ss_count">(0)</span></a>'
                    + '</li>';
            } );
            output += template.replace( new RegExp( '{% HEADING %}' ), attribute ).replace( new RegExp( '{% FILTER CLASS %}' ), 'filter_' + attribute.toLowerCase() ).replace( new RegExp( '{% LIST %}' ), itemsHTML );
        } );

        $( '.ss_modal_sidebar ul' ).html( output );

        updateCategoryCounts( products );
        updateAttribCounts( products );

        $( '.ss_modal_sidebar li[data-type]' ).removeClass( 'active' );
        _.forEach( selectedParams, (selection) => {
            _.forEach( selection, (selectionValue, selectionType) => {
                let elm = '*[data-type="' + selectionType + '"][data-value="' + selectionValue + '"]';
                $( elm ).addClass( 'active' );
                $( elm ).find( 'ul' ).addClass( 'active' );
                $( elm ).parents( 'li[data-type]' ).addClass( 'active' );
            } );
        } );
    }

    function checkCardToShow() {
        $('.ss_modal_sidebar li ul').each(function(index) {
            if ($(this).children(':visible').length == 0) {
                $(this).closest('li').hide();
            }
        });
    }

    function updateCategoryCounts(products) {
        for ( let i in groupedCategories ) {
            let mainCatItems = 0;
            _.forEach( groupedCategories[i], cat => {
                let count = 0;
                _.forEach( products, p => {
                    _.forEach( p.cat, c1 => {
                        if ( !Array.isArray( c1.childs ) || c1.childs.length == 0 ) {
                            if ( c1.id == cat ) {
                                count++;
                            }
                        } else {
                            _.forEach( c1.childs, c2 => {
                                if ( !Array.isArray( c2.childs ) || c2.childs.length == 0 ) {
                                    if ( c2.id == cat ) {
                                        count++;
                                    }
                                } else {
                                    _.forEach( c2.childs, c3 => {
                                        if ( c3.id == cat ) {
                                            count++;
                                        }
                                    } );
                                }
                            } );
                        }
                    } );
                } );
                mainCatItems += count;

                $( '*[data-type="cat"][data-value="' + cat + '"]' ).find( '.ss_count' ).html( '(' + count + ')' );

                if ( count > 0 ) {
                    $( '*[data-type="cat"][data-value="' + cat + '"]' ).show();
                } else {
                    $( '*[data-type="cat"][data-value="' + cat + '"]' ).hide();
                }
            } );
        }

        checkCardToShow();
    }

    function updateAttribCounts(products) {
        products = (getSelectedCategory() || dlgSearchField.val()) ? categoryProducts : productsData;
        let flatAttributes = [];
        _.forEach( defaultAttributes, (values, attrib) => {
            _.forEach( values, val => {
                flatAttributes.push( { [attrib]: val.name.toString().replace( "\"", "" ) } );
            } );
        } );
        _.forEach( flatAttributes, attrib => {
            let key = Object.keys( attrib )[0];
            let val = attrib[key];
            let count = 0;
            _.forEach( products, p => {
                if ( Array.isArray( p.attributes[key] ) ) {
                    if ( p.attributes[key].map( kv => kv.replace( "\"", "" ) ).includes( val ) ) {
                        count++;
                    }
                }
            } );

            $( '*[data-type="' + key + '"][data-value="' + val + '"]' ).find( '.ss_count' ).html( '(' + count + ')' );

            if ( count > 0 ) {
                $( '*[data-type="' + key + '"][data-value="' + val + '"]' ).show();
            } else {
                $( '*[data-type="' + key + '"][data-value="' + val + '"]' ).hide();
            }
        } );

        // hide any card which does not have any attributes
        checkCardToShow();
    }

    $( document ).on( 'click', '.ss_clear_search', function () {
        searchField.val( '' );
        dlgSearchField.val( '' );
        catSelected = null;
        attribSelected = null;
        attribSelectedValue = null;
        selectedParams = [];
        total_pages = 0;
        applySearch( '' );
    } );

    $( document ).on( 'click', '.ss_mobile_menu', function () {
        $( '.ss_modal .ss_modal_content .ss_modal_sidebar' ).toggleClass( 'active' );
    } );

    $( document ).on( 'keyup', '#searching', function (e) {

        const val = $(this).val();
        const regex = /(<([^>]+)>)/ig;
        const result = val.replace(regex, '');
        const value = $(this).val(result);

        if ( value.length < psfSearchConfigs.settings.suggestion_characters && searchPopup.css( 'display' ) === 'block' ) {
        }
    } );

    $( document ).on( 'keyup', '#smart_search', function (e) {
        const val = $(this).val();
        const regex = /(<([^>]+)>)/ig;
        const result = val.replace(regex, '');
        const value = $(this).val(result);

        if ( value.length >= psfSearchConfigs.settings.suggestion_characters && searchPopup.css( 'display' ) !== 'block' ) {
            showsearchPopup( value );
        }
    } );

    $( document ).on( 'click', '#smart_search', function (e) {
        let value = $( this ).val();
        if ( value.length >= psfSearchConfigs.settings.suggestion_characters ) {
            showsearchPopup( value );
        }
    } );

    if ( psfSearchConfigs.settings.override_woocommerce_search == 'yes' ) {
        $( document ).on( 'keyup', 'input[name="s"]', function (e) {
            let value = $( this ).val();
            if ( value.length >= psfSearchConfigs.settings.suggestion_characters && searchPopup.css( 'display' ) !== 'block' ) {
                showsearchPopup( value );
            }
        } );

        $( document ).on( 'click', 'input[name="s"]', function (e) {
            let value = $( this ).val();
            if ( value.length >= psfSearchConfigs.settings.suggestion_characters ) {
                showsearchPopup( value );
            }
        } );
    }

    $( document ).on( 'click', '.ss_modal_overlay', function () {
        hidesearchPopup();
    } );

    dlgSearchField.on( 'keyup', function (e) {
        applySearch( dlgSearchField.val() );
    } );

    [btnToggleSidebar, btnCancel].forEach( (el) => {
        el.on( 'click', function () {
            toggleSidebar();
        } );
    } );

    function toggleSidebar() {
        const x = $('#list');
        x.css( 'display', x.css( 'display' ) == "none" ? 'block' : 'none' );
    }

    function showsearchPopup(val) {
        let dextr = val;
        if ( typeof dextr === 'object' ) {
            dextr = val.val();
        }
        const regex = /^[a-z0-9 ]+$/i;
        if ( !regex.test( dexter ) ) {
            dextr = '';
        }

        searchPopup.css( 'display', 'block' );

        dlgSearchField.val( dextr );

        dlgSearchField.focus();
        applySearch( dlgSearchField.val() );
        $( '.ss_modal_overlay' ).show();
        $( 'body' ).attr( 'style', 'overflow: hidden !important' );
    }

    function hidesearchPopup() {
        $( '#smart_search, input[name="s"]' ).val( dlgSearchField.val() );
        searchPopup.css( 'display', 'none' );
        $( '.ss_modal_overlay' ).hide();
        $( 'body' ).css( 'overflow', 'auto' );
    }

    dlgCloseHandle.on( 'click', function () {
        hidesearchPopup();
    } );

    // When the user clicks anywhere outside of the modal, close it
    window.onclick = function (event) {
        if ( event.target == searchPopup ) {
            hidesearchPopup();
        }
    }

    // Pagination Events
    $( document ).on( 'click', '.ss_modal_results_pagination ul a:not(.goto-first-page):not(.goto-last-page):not(.goto-prev-page):not(.goto-next-page)', function () {
        renderProducts( paginationSearchTerm, paginationProducts, $( this ).text() );
    } );
    $( document ).on( 'click', '.ss_modal_results_pagination ul a.goto-first-page', function () {
        renderProducts( paginationSearchTerm, paginationProducts, 1 );
    } );
    $( document ).on( 'click', '.ss_modal_results_pagination ul a.goto-last-page', function () {
        renderProducts( paginationSearchTerm, paginationProducts, total_pages );
    } );
    $( document ).on( 'click', '.ss_modal_results_pagination ul a.goto-next-page', function () {
        if ( paginationCurrentPage < total_pages ) {
            paginationCurrentPage++;
        }
        renderProducts( paginationSearchTerm, paginationProducts, paginationCurrentPage );
    } );
    $( document ).on( 'click', '.ss_modal_results_pagination ul a.goto-prev-page', function () {
        if ( paginationCurrentPage > 1 ) {
            paginationCurrentPage--;
        }
        renderProducts( paginationSearchTerm, paginationProducts, paginationCurrentPage );
    } );
} );
