<?php

/**
 * Product search popup template file
 *
 * @link       https://kankode.com/
 * @since      1.0.0
 *
 * @package    Product_Search_Filters
 * @subpackage Psf_Product_Search_Filters/public/partials
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

$settings = get_option( 'psf_search_settings' );
?>

<div class="ss_modal_overlay"></div>
<div id="searchPopup" class="ss_modal">
    <div class="ss_modal_header clearfix">
        <div class="ss_modal_clear">
            <a href="javascript:void(0);"
               class="ss_clear_search"><?php esc_html_e( 'Clear Refinements', 'product-search-and-filters' ); ?></a>
        </div>
        <div class="ss_modal_search">
            <a href="javascript:void(0);" class="ss_mobile_menu"><?php esc_html_e( 'Menu', 'product-search-and-filters' ); ?></a>
            <label>
                <input type="text" name="search" id="searching">
            </label>
            <a href="javascript:void(0);" id="popup_close_button">x</a>
        </div>
    </div>
    <div class="ss_modal_content clearfix">
        <div class="ss_modal_sidebar">
            <a href="javascript:void(0);"
               class="ss_clear_search ss_mobile_clear_search"><?php esc_html_e( 'Clear Refinements', 'product-search-and-filters' ); ?></a>
            <ul></ul>
        </div>
        <div class="ss_modal_results">
            <div class="ss_modal_results_item clearfix">
                <ul></ul>
            </div>
            <div class="ss_modal_results_pagination">
                <ul></ul>
            </div>
        </div>
    </div>
</div>
